/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.tutorial.service.blogic;

import java.util.HashMap;
import java.util.Map;

import jp.terasoluna.fw.dao.QueryDAO;
import jp.terasoluna.fw.dao.UpdateDAO;
import jp.terasoluna.thin.tutorial.service.bean.UserBean;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * 入力情報登録ビジネスロジック。
 *
 * 画面から入力された値をデータベースに登録する。
 *
 */
public class RegisterBLogicImpl implements RegisterBLogic{

    /**
     * ログクラス。
     */
    private Log log = LogFactory.getLog(RegisterBLogicImpl.class);

    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private UpdateDAO updateDAO = null;

    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private QueryDAO queryDAO = null;

    /**
     * UpdateDAOを返却する。
     *
     * @return 保持するUpdateDAO
     */
    public UpdateDAO getUpdateDAO() {
        return updateDAO;
    }

    /**
     * UpdateDAOを設定する。
     *
     * @param updateDAO UpdateDAO
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }

    /**
     * QueryDAOを返却する。
     *
     * @return 保持するQueryDAO
     */
    public QueryDAO getQueryDAO() {
        return queryDAO;
    }

    /**
     * QueryDAOを設定する。
     *
     * @param queryDAO QueryDAO
     */
    public void setQueryDAO(QueryDAO queryDAO) {
        this.queryDAO = queryDAO;
    }

    /**
     * 入力された情報をデータベースに登録する。
     * 登録に成功した件数を返却する。
     *
     * @param bean 画面にて入力された値を保持するBean
     * @return 登録結果
     */
    public boolean register(UserBean bean) {

        if (log.isDebugEnabled()) {
            log.debug("register Start.");
        }

        //重複チェック実行
        //エラーの場合は、falseを返却する。
        if (!check(bean)) {
            return false;
        }

        //登録後、結果件数を返却する。
        updateDAO.execute("insertUser", bean);

        return true;
    }

    /**
     * 入力されたIDが重複か否かをデータベースから取得して判定する。
     * 重複している場合は、falseを返却する。
     * 重複していない場合は、trueを返却する。
     *
     * @param bean 画面にて入力された値を保持するBean
     * @return チェック結果
     */
    protected boolean check(UserBean bean) {

        if (log.isDebugEnabled()) {
            log.debug("check Start.");
        }

        //IDからデータを検索する。
        Map<String, Long> params = new HashMap<String, Long>();
        params.put("ID", bean.getId());
        Map<String, Object>[] result
            = queryDAO.executeForMapArray("getUser", params);

        //IDで検索し、データが取得できた場合は、重複エラーとする。
        if (result != null && result.length > 0) {
            return false;
        }

        //データが取得できなかった場合は、重複していないとして
        //trueを返却する。
        return true;
    }
}
